/*----- PROTECTED REGION ID(SeqUtilsClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: SeqUtilsClass.cpp,v 1.6 2020-01-15 10:29:01 giulio Exp $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/sequtils/src/SeqUtilsClass.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        SeqUtilsClass.cpp
//
// description : C++ source for the SeqUtilsClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the SeqUtils once per process.
//
// project :     SeqUtils
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <SeqUtilsClass.h>

/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass.cpp

//-------------------------------------------------------------------
/**
 *	Create SeqUtilsClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_SeqUtils_class(const char *name) {
		return SeqUtils_ns::SeqUtilsClass::init(name);
	}
}

namespace SeqUtils_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
SeqUtilsClass *SeqUtilsClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		SeqUtilsClass::SeqUtilsClass(string &s)
 * description : 	constructor for the SeqUtilsClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
SeqUtilsClass::SeqUtilsClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering SeqUtilsClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(SeqUtilsClass::constructor) ENABLED START -----*/
	string tagname(TagName);
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::constructor

	cout2 << "Leaving SeqUtilsClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		SeqUtilsClass::~SeqUtilsClass()
 * description : 	destructor for the SeqUtilsClass
 */
//--------------------------------------------------------
SeqUtilsClass::~SeqUtilsClass()
{
	/*----- PROTECTED REGION ID(SeqUtilsClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		SeqUtilsClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
SeqUtilsClass *SeqUtilsClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new SeqUtilsClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		SeqUtilsClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
SeqUtilsClass *SeqUtilsClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OnClass::execute(): arrived" << endl;
	((static_cast<SeqUtils *>(device))->on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OffClass::execute(): arrived" << endl;
	((static_cast<SeqUtils *>(device))->off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ResetClass::execute(): arrived" << endl;
	((static_cast<SeqUtils *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetFaultClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetFaultClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetFaultClass::execute(): arrived" << endl;
	((static_cast<SeqUtils *>(device))->set_fault());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StartClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StartClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StartClass::execute(): arrived" << endl;
	((static_cast<SeqUtils *>(device))->start());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<SeqUtils *>(device))->stop());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum SeqUtilsClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum SeqUtilsClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum SeqUtilsClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void SeqUtilsClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void SeqUtilsClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("SeqUtils");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("It returns a random generated number, sec/nsec date");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void SeqUtilsClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(SeqUtilsClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new SeqUtils(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		SeqUtils *dev = static_cast<SeqUtils *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(SeqUtilsClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void SeqUtilsClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(SeqUtilsClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::attribute_factory_before
	//	Attribute : DRand
	DRandAttrib	*drand = new DRandAttrib();
	Tango::UserDefaultAttrProp	drand_prop;
	//	description	not set for DRand
	//	label	not set for DRand
	//	unit	not set for DRand
	//	standard_unit	not set for DRand
	//	display_unit	not set for DRand
	drand_prop.set_format("%f");
	drand_prop.set_max_value("500000000000");
	drand_prop.set_min_value("-500000000000");
	//	max_alarm	not set for DRand
	//	min_alarm	not set for DRand
	//	max_warning	not set for DRand
	//	min_warning	not set for DRand
	//	delta_t	not set for DRand
	//	delta_val	not set for DRand
	
	drand->set_default_properties(drand_prop);
	//	Not Polled
	drand->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(drand);

	//	Attribute : DRandMin
	DRandMinAttrib	*drandmin = new DRandMinAttrib();
	Tango::UserDefaultAttrProp	drandmin_prop;
	//	description	not set for DRandMin
	//	label	not set for DRandMin
	//	unit	not set for DRandMin
	//	standard_unit	not set for DRandMin
	//	display_unit	not set for DRandMin
	drandmin_prop.set_format("%f");
	drandmin_prop.set_max_value("500000000000");
	drandmin_prop.set_min_value("-500000000000");
	//	max_alarm	not set for DRandMin
	//	min_alarm	not set for DRandMin
	//	max_warning	not set for DRandMin
	//	min_warning	not set for DRandMin
	//	delta_t	not set for DRandMin
	//	delta_val	not set for DRandMin
	
	drandmin->set_default_properties(drandmin_prop);
	//	Not Polled
	drandmin->set_disp_level(Tango::OPERATOR);
	drandmin->set_memorized();
	drandmin->set_memorized_init(true);
	att_list.push_back(drandmin);

	//	Attribute : DRandMax
	DRandMaxAttrib	*drandmax = new DRandMaxAttrib();
	Tango::UserDefaultAttrProp	drandmax_prop;
	//	description	not set for DRandMax
	//	label	not set for DRandMax
	//	unit	not set for DRandMax
	//	standard_unit	not set for DRandMax
	//	display_unit	not set for DRandMax
	drandmax_prop.set_format("%f");
	drandmax_prop.set_max_value("500000000000");
	drandmax_prop.set_min_value("-500000000000");
	//	max_alarm	not set for DRandMax
	//	min_alarm	not set for DRandMax
	//	max_warning	not set for DRandMax
	//	min_warning	not set for DRandMax
	//	delta_t	not set for DRandMax
	//	delta_val	not set for DRandMax
	
	drandmax->set_default_properties(drandmax_prop);
	//	Not Polled
	drandmax->set_disp_level(Tango::OPERATOR);
	drandmax->set_memorized();
	drandmax->set_memorized_init(true);
	att_list.push_back(drandmax);

	//	Attribute : LRand
	LRandAttrib	*lrand = new LRandAttrib();
	Tango::UserDefaultAttrProp	lrand_prop;
	//	description	not set for LRand
	//	label	not set for LRand
	//	unit	not set for LRand
	//	standard_unit	not set for LRand
	//	display_unit	not set for LRand
	//	format	not set for LRand
	lrand_prop.set_max_value("2147483647");
	lrand_prop.set_min_value("-2147483648");
	//	max_alarm	not set for LRand
	//	min_alarm	not set for LRand
	//	max_warning	not set for LRand
	//	min_warning	not set for LRand
	//	delta_t	not set for LRand
	//	delta_val	not set for LRand
	
	lrand->set_default_properties(lrand_prop);
	//	Not Polled
	lrand->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(lrand);

	//	Attribute : LRandMin
	LRandMinAttrib	*lrandmin = new LRandMinAttrib();
	Tango::UserDefaultAttrProp	lrandmin_prop;
	//	description	not set for LRandMin
	//	label	not set for LRandMin
	//	unit	not set for LRandMin
	//	standard_unit	not set for LRandMin
	//	display_unit	not set for LRandMin
	//	format	not set for LRandMin
	lrandmin_prop.set_max_value("2147483647");
	lrandmin_prop.set_min_value("-2147483648");
	//	max_alarm	not set for LRandMin
	//	min_alarm	not set for LRandMin
	//	max_warning	not set for LRandMin
	//	min_warning	not set for LRandMin
	//	delta_t	not set for LRandMin
	//	delta_val	not set for LRandMin
	
	lrandmin->set_default_properties(lrandmin_prop);
	//	Not Polled
	lrandmin->set_disp_level(Tango::OPERATOR);
	lrandmin->set_memorized();
	lrandmin->set_memorized_init(true);
	att_list.push_back(lrandmin);

	//	Attribute : LRandMax
	LRandMaxAttrib	*lrandmax = new LRandMaxAttrib();
	Tango::UserDefaultAttrProp	lrandmax_prop;
	//	description	not set for LRandMax
	//	label	not set for LRandMax
	//	unit	not set for LRandMax
	//	standard_unit	not set for LRandMax
	//	display_unit	not set for LRandMax
	//	format	not set for LRandMax
	lrandmax_prop.set_max_value("2147483647");
	lrandmax_prop.set_min_value("-2147483648");
	//	max_alarm	not set for LRandMax
	//	min_alarm	not set for LRandMax
	//	max_warning	not set for LRandMax
	//	min_warning	not set for LRandMax
	//	delta_t	not set for LRandMax
	//	delta_val	not set for LRandMax
	
	lrandmax->set_default_properties(lrandmax_prop);
	//	Not Polled
	lrandmax->set_disp_level(Tango::OPERATOR);
	lrandmax->set_memorized();
	lrandmax->set_memorized_init(true);
	att_list.push_back(lrandmax);

	//	Attribute : Data
	DataAttrib	*data = new DataAttrib();
	Tango::UserDefaultAttrProp	data_prop;
	//	description	not set for Data
	//	label	not set for Data
	//	unit	not set for Data
	//	standard_unit	not set for Data
	//	display_unit	not set for Data
	//	format	not set for Data
	//	max_value	not set for Data
	//	min_value	not set for Data
	//	max_alarm	not set for Data
	//	min_alarm	not set for Data
	//	max_warning	not set for Data
	//	min_warning	not set for Data
	//	delta_t	not set for Data
	//	delta_val	not set for Data
	
	data->set_default_properties(data_prop);
	//	Not Polled
	data->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(data);

	//	Attribute : Data1
	Data1Attrib	*data1 = new Data1Attrib();
	Tango::UserDefaultAttrProp	data1_prop;
	//	description	not set for Data1
	//	label	not set for Data1
	//	unit	not set for Data1
	//	standard_unit	not set for Data1
	//	display_unit	not set for Data1
	//	format	not set for Data1
	//	max_value	not set for Data1
	//	min_value	not set for Data1
	//	max_alarm	not set for Data1
	//	min_alarm	not set for Data1
	//	max_warning	not set for Data1
	//	min_warning	not set for Data1
	//	delta_t	not set for Data1
	//	delta_val	not set for Data1
	
	data1->set_default_properties(data1_prop);
	//	Not Polled
	data1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(data1);

	//	Attribute : LData
	LDataAttrib	*ldata = new LDataAttrib();
	Tango::UserDefaultAttrProp	ldata_prop;
	//	description	not set for LData
	//	label	not set for LData
	//	unit	not set for LData
	//	standard_unit	not set for LData
	//	display_unit	not set for LData
	//	format	not set for LData
	//	max_value	not set for LData
	//	min_value	not set for LData
	//	max_alarm	not set for LData
	//	min_alarm	not set for LData
	//	max_warning	not set for LData
	//	min_warning	not set for LData
	//	delta_t	not set for LData
	//	delta_val	not set for LData
	
	ldata->set_default_properties(ldata_prop);
	//	Not Polled
	ldata->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(ldata);

	//	Attribute : Date
	DateAttrib	*date = new DateAttrib();
	Tango::UserDefaultAttrProp	date_prop;
	//	description	not set for Date
	//	label	not set for Date
	//	unit	not set for Date
	//	standard_unit	not set for Date
	//	display_unit	not set for Date
	//	format	not set for Date
	//	max_value	not set for Date
	//	min_value	not set for Date
	//	max_alarm	not set for Date
	//	min_alarm	not set for Date
	//	max_warning	not set for Date
	//	min_warning	not set for Date
	//	delta_t	not set for Date
	//	delta_val	not set for Date
	
	date->set_default_properties(date_prop);
	//	Not Polled
	date->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(date);

	//	Attribute : LDate
	LDateAttrib	*ldate = new LDateAttrib();
	Tango::UserDefaultAttrProp	ldate_prop;
	//	description	not set for LDate
	//	label	not set for LDate
	//	unit	not set for LDate
	//	standard_unit	not set for LDate
	//	display_unit	not set for LDate
	//	format	not set for LDate
	//	max_value	not set for LDate
	//	min_value	not set for LDate
	//	max_alarm	not set for LDate
	//	min_alarm	not set for LDate
	//	max_warning	not set for LDate
	//	min_warning	not set for LDate
	//	delta_t	not set for LDate
	//	delta_val	not set for LDate
	
	ldate->set_default_properties(ldate_prop);
	//	Not Polled
	ldate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(ldate);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(SeqUtilsClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void SeqUtilsClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(SeqUtilsClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::pipe_factory_before
	/*----- PROTECTED REGION ID(SeqUtilsClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void SeqUtilsClass::command_factory()
{
	/*----- PROTECTED REGION ID(SeqUtilsClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::command_factory_before


	//	Command On
	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);

	//	Command Off
	OffClass	*pOffCmd =
		new OffClass("Off",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOffCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command SetFault
	SetFaultClass	*pSetFaultCmd =
		new SetFaultClass("SetFault",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSetFaultCmd);

	//	Command Start
	StartClass	*pStartCmd =
		new StartClass("Start",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStartCmd);

	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	/*----- PROTECTED REGION ID(SeqUtilsClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		SeqUtilsClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void SeqUtilsClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(SeqUtilsClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		SeqUtilsClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void SeqUtilsClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		SeqUtils *dev = static_cast<SeqUtils *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(SeqUtilsClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtilsClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *SeqUtilsClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(SeqUtilsClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::Additional Methods
} //	namespace
