/*----- PROTECTED REGION ID(SeqUtilsStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        SeqUtilsStateMachine.cpp
//
// description : State machine file for the SeqUtils class
//
// project :     SeqUtils
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <SeqUtils.h>

/*----- PROTECTED REGION END -----*/	//	SeqUtils::SeqUtilsStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  ON      |  
//  OFF     |  
//  FAULT   |  


namespace SeqUtils_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_DRand_allowed()
 *	Description : Execution allowed for DRand attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_DRand_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DRand attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::DRandStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DRandStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_DRandMin_allowed()
 *	Description : Execution allowed for DRandMin attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_DRandMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DRandMin attribute in Write access.
	/*----- PROTECTED REGION ID(SeqUtils::DRandMinStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DRandMinStateAllowed_WRITE

	//	Not any excluded states for DRandMin attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::DRandMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DRandMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_DRandMax_allowed()
 *	Description : Execution allowed for DRandMax attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_DRandMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DRandMax attribute in Write access.
	/*----- PROTECTED REGION ID(SeqUtils::DRandMaxStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DRandMaxStateAllowed_WRITE

	//	Not any excluded states for DRandMax attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::DRandMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DRandMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_LRand_allowed()
 *	Description : Execution allowed for LRand attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_LRand_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LRand attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::LRandStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::LRandStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_LRandMin_allowed()
 *	Description : Execution allowed for LRandMin attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_LRandMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LRandMin attribute in Write access.
	/*----- PROTECTED REGION ID(SeqUtils::LRandMinStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::LRandMinStateAllowed_WRITE

	//	Not any excluded states for LRandMin attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::LRandMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::LRandMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_LRandMax_allowed()
 *	Description : Execution allowed for LRandMax attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_LRandMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LRandMax attribute in Write access.
	/*----- PROTECTED REGION ID(SeqUtils::LRandMaxStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::LRandMaxStateAllowed_WRITE

	//	Not any excluded states for LRandMax attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::LRandMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::LRandMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_Data_allowed()
 *	Description : Execution allowed for Data attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_Data_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(SeqUtils::DataStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DataStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for Data attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::DataStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DataStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_Data1_allowed()
 *	Description : Execution allowed for Data1 attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_Data1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Data1 attribute in Write access.
	/*----- PROTECTED REGION ID(SeqUtils::Data1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::Data1StateAllowed_WRITE

	//	Not any excluded states for Data1 attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::Data1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::Data1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_LData_allowed()
 *	Description : Execution allowed for LData attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_LData_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(SeqUtils::LDataStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	SeqUtils::LDataStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for LData attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::LDataStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::LDataStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_Date_allowed()
 *	Description : Execution allowed for Date attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_Date_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Date attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::DateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::DateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_LDate_allowed()
 *	Description : Execution allowed for LDate attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_LDate_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LDate attribute in read access.
	/*----- PROTECTED REGION ID(SeqUtils::LDateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::LDateStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_On_allowed()
 *	Description : Execution allowed for On attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_On_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(SeqUtils::OnStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::OnStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_Off_allowed()
 *	Description : Execution allowed for Off attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_Off_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(SeqUtils::OffStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::OffStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_Reset_allowed()
 *	Description : Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(SeqUtils::ResetStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_SetFault_allowed()
 *	Description : Execution allowed for SetFault attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_SetFault_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetFault command.
	/*----- PROTECTED REGION ID(SeqUtils::SetFaultStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::SetFaultStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_Start_allowed()
 *	Description : Execution allowed for Start attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_Start_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Start command.
	/*----- PROTECTED REGION ID(SeqUtils::StartStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::StartStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : SeqUtils::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool SeqUtils::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(SeqUtils::StopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtils::StopStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(SeqUtils::SeqUtilsStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	SeqUtils::SeqUtilsStateAllowed.AdditionalMethods

}	//	End of namespace
